#!/usr/bin/env perl
# for converting from Combilex SIN notation to ALINE convention
# cloned from ~/prepa/celex/aline/cel2lad.p in Jul 2010 by Greg Kondrak

use strict;

my @SIN = qw( p b t d k g N  m n l r f v T  D  s z S  Z  j ? h w
              C  J  ? F H P ? I  E  a  V   Q   U  @  i  A   O  u   3
              e  2  4  o  6  7  8   9  c  q  0  ~ );

my @LAD = qw( p b t d k g gN m n l r f v sD zD s z sV zV y x h w
              cV jV n m n l r iL eL aF eCL aBR uL eC iH aBH oLH uH eCH
              eH aH oH oH aH iH eLH uH aFN aBNH aFNH aBRN );

my %sin2lad;
for (my $c = 32; $c < 128; $c++) { $sin2lad{chr($c)} = "!"; }
for (my $i = 0; $i < @SIN; $i++) { $sin2lad{$SIN[$i]} = $LAD[$i]; }
$sin2lad{"L"} = "l";
$sin2lad{"?"} = "?";

while (<>) { print join('', (map { $sin2lad{$_} } (split //))), "\n"; }

