#!/usr/bin/env python3

from collections import defaultdict
from operator import itemgetter
from sys import argv, stdin

__author__ = 'Aditya Bhargava'
__license__ = 'FreeBSD'
__version__ = '1.0.0'
__email__ = 'aditya@cs.toronto.edu'


min1 = float(argv[1])
max1 = float(argv[2])
min2 = float(argv[3])
max2 = float(argv[4])
l = float(argv[5])

SCORE_LOWER = -100
data = defaultdict(list)
enlist = []
for line in stdin.readlines():
    en, ph, score1, score2 = line.split()
    # score1 is base system, score2 is M2M/ALINE
    try:
        score2 = float(score2)
        if score2 < SCORE_LOWER:
            score2 = SCORE_LOWER
    except ValueError:
        score2 = SCORE_LOWER
    score = (float(score1) - min1) * l / (max1 - min1) + (score2 - min2) * \
            (1 - l) / (max2 - min2)
    data[en].append((ph, score))
    if en not in enlist:
        enlist.append(en)

for en in enlist:
    data[en] = sorted(data[en], key=itemgetter(1), reverse=True)
    for ph, score in data[en]:
        print(en, ph, score, sep='\t')
