#!/usr/bin/env python3

from collections import defaultdict
from operator import itemgetter
from sys import argv, stdin

__author__ = 'Aditya Bhargava'
__license__ = 'FreeBSD'
__version__ = '1.0.0'
__email__ = 'aditya@cs.toronto.edu'


refdata = defaultdict(list)
with open(argv[1]) as inp:
    for line in inp:
        k, v = line.strip().split('\t')
        refdata[k].append(v)

SCORE_LOWER = -100
data = defaultdict(list)
enlist = []
for line in stdin.readlines():
    en, ph, score1, score2 = line.split()
    # score1 is base system, score2 is M2M/ALINE
    try:
        score2 = float(score2)
        if score2 < SCORE_LOWER:
            score2 = SCORE_LOWER
    except ValueError:
        score2 = SCORE_LOWER
    data[en].append((ph, float(score1), score2))
    if en not in enlist:
        enlist.append(en)

min1, max1 = float('inf'), float('-inf')
min2, max2 = float('inf'), float('-inf')
for en in data:
    for ph, score1, score2 in data[en]:
        min1 = min(min1, score1)
        max1 = max(max1, score1)
        min2 = min(min2, score2)
        max2 = max(max2, score2)

maxwacc = 0
bestl = 0
for l in range(1001):
    wacc = 0
    for en in enlist:
        data[en] = sorted(data[en], key=lambda t: (t[1] - min1) * l / (max1 -
                                                                       min1) +
                          (t[2] - min2) * (1000 - l) / (max2 - min2),
                          reverse=True)
        if data[en][0][0] in refdata[en]:
            wacc += 1
    if wacc > maxwacc:
        maxwacc = wacc
        bestl = l / 1000

print(min1, max1, min2, max2, bestl)
