#!/usr/bin/env python3

from collections import defaultdict
from sys import argv, stdin

__author__ = 'Aditya Bhargava'
__license__ = 'FreeBSD'
__version__ = '1.0.0'
__email__ = 'aditya@cs.toronto.edu'


ref = defaultdict(list)
with open(argv[1]) as inp:
    for line in inp:
        en, ph = line.strip().split('\t')
        ref[en].append(ph)

base = defaultdict(list)
with open(argv[2]) as inp:
    for line in inp:
        en, ph = line.strip().split('\t')
        base[en].append(ph)

data = defaultdict(list)
for line in stdin.readlines():
    stuff = line.split()
    num = (len(stuff) - 6) // 3
    #if num == 9:
        #print(line, end = '')
    en, ph = stuff[0:2]
    data[en].append([ph, num])

tally = defaultdict(lambda: [0, 0])
for en in data:
    num = max(data[en], key=lambda l: l[1])[1]
    tally[num][1] += 1
    if data[en][0][0] in ref[en]:
        tally[num][0] += 1
    if base[en][0] in ref[en]:
        tally[num][0] -= 1

top, bottom = 0, 0
for num in sorted(tally):
    top += tally[num][0]
    bottom += tally[num][1]
    print('{}\t{}\t{:.2f}\t{}\t{:.2f}'.format(num, tally[num][1],
                                              tally[num][0] * 100 /
                                              tally[num][1], bottom,
                                              top * 100 / bottom))
