#!/bin/bash

# For development, leave the this parameter empty; alternatively, if you want to
# use the next parameters as well (maxX, maxY), set it to 0
if [[ -z $2 || $2 -eq 0 ]]
then
    iter="--tal 5"
elif [ $2 -gt 5 ] # 5 is a recommendation from the DirecTL+ author
then
    iter="--tal 5 --tam $2"
else
    iter="--tam 5"
fi

if [ -z $3 ]
then
    maxX=2
else
    maxX=$3
fi
if [ -z $4 ]
then
    maxY=2
else
    maxY=$4
fi


m2m-aligner --delX --maxX $maxX --maxY $maxY --inFormat l2p -i $1.trn
m2m-aligner --delX --maxX $maxX --maxY $maxY --inFormat l2p --alignerIn \
    $1.trn.*.model -i $1.tst
rm $1.*.err # probably empty files, and not really helpful regardless
cut -f 1 $1.tst.*.align | sed -e 's/:/|/g' | uniq > $1.tst.words

# to add a dev set (which we do only in the development phase) use -d TSTFILE,
# e.g. -d $1.tst.*.align
directlp --inChar : $iter --order 1 --linearChain --jointMgram 4 -f \
    $1.trn.*.align -t $1.tst.words -a $1.tst.words.output \
    --nBestTest 10
sed -i -e '/^$/d' $1.tst.words.output.phraseOut
