#!/bin/bash

declare -A langs
langs=([ba]=4 [ch]=5 [hi]=6 [ja]=7 [ka]=8 [ko]=9 [ru]=10 [ta]=11 [th]=12)

for sys in fest seq dtlp
do
    for suf in trn tst
    do
        f="$1.$suf.$sys"
        ./getExternal.py ??????.$suf < ../$f > $f.more

        for l in ${!langs[@]}
        do
            cut -f ${langs[$l]},13 $f.more > $f.${l}ph
            m2m-aligner --pScore --errorInFile --alignerIn \
                ${l}ph.trn.m-mAlign.2-2.delX.1-best.conYX.align.model -i $f.${l}ph
        done
    done
done

rm *.err
sed -i -e 's/NO ALIGNMENT \t/NALGN\tNALGN\tNULL\tNULL/' -e 's/://g' \
    *.??ph.*.align

for sys in fest seq dtlp
do
    for suf in trn tst
    do
        f="$1.$suf.$sys"
        for l in ${!langs[@]}
        do
            paste $f.${l}ph $f.${l}ph.*.align | sed -e \
                '/^NULL\t/s/NALGN/NULL/g' | cut -f 3,4,6 > $f.${l}ph.tmp
        done

        cut -f 1-3 $f.more | paste - $f.??ph.tmp > ../$f.all
        rm *.tmp
    done
done
